package io.zipcoder.casino;

public class HighLow extends DiceGame{
    private Player player;
    private boolean isPlaying = true;
    private int rolledDiceResult;
    private int totalBet;
    private String betCondition;
    private int winnings;

    public HighLow(Player player) {
        this.player = player;
    }

    private int askForWager() {
        int wager = 0;
        boolean flag = true;
        Console.output("Current bankroll: " + this.player.getBankroll());
        while (flag) {
            try {
                wager = Console.askForInteger("How much would you like to bet?");
                if (wager <= 0 || wager > this.player.getBankroll()) {
                    Console.output("Wrong input! Try again!");
                } else {
                    flag = false;
                }
            } catch(NumberFormatException e) {
                Console.output("Wrong input! Try again!");
            }
        }
        this.player.subtractFromBankroll(wager);
        return wager;
    }

    public String makeBet() {
        betCondition = Console.askForInput("What are you betting on?  (H / L / 7)");
        if (betCondition.toLowerCase().equals("h") ||
            betCondition.toLowerCase().equals("l") ||
            betCondition.toLowerCase().equals("7")) {
                return betCondition;
        }
        Console.output("Wrong input. Please try again");
        return makeBet();
    }

    public int rollDice() {
        Dice dice = new Dice(2);
        rolledDiceResult = dice.getSum();
        Console.output("You rolled " + rolledDiceResult);
        return rolledDiceResult;
    }

    public void declareWinner() {
        if ((betCondition.toUpperCase().equals("H") && rolledDiceResult >  7) ||
                (betCondition.toUpperCase().equals("L") && rolledDiceResult <  7) ||
                (betCondition.toUpperCase().equals("7") && rolledDiceResult == 7)) {
            winnings = rolledDiceResult == 7 ? this.totalBet * 4 : this.totalBet * 2;
            winBet();
        } else {
            loseBet();
        }
    }

    public boolean askToContinue() {
        if (this.player.getBankroll() == 0) {
            Console.output("You're bankrupt! Please come back after pay day!");
            return false;
        }
        String input = Console.askForInput("Would you like to continue?  (Y / N)");
        if (input.toLowerCase().equals("y")) {
            return true;
        } else if (input.toLowerCase().equals("n")) {
            return false;
        }
        Console.output("Wrong input. Please try again");
        return askToContinue();
    }

    public void winBet() {
        player.addToBankroll(winnings);
        Console.output("You won " + winnings);
    }

    public void loseBet() {
        Console.output("You lost :(");
    }

    public void startGame() {
        Console.output("You're playing High-Low dice game");
        while (isPlaying) {
            totalBet         = askForWager();
            betCondition     = makeBet();
            rolledDiceResult = rollDice();
            declareWinner();
            isPlaying        = askToContinue();
        }
       // endGame();
    }

    public void endGame() {
        //???
    }

    public static void main (String[] args) {
        Player player = new Player("Francis");
        DiceGame app = new HighLow(player);
        app.startGame();
    }
}